#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdio.h>

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspsdk.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pspnet.h>
#include <pspnet_inet.h>
#include <pspnet_apctl.h>
#include <pspnet_resolver.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/select.h>
#include <errno.h>

#define BUFLEN 512
#define NPACK 10
#define PORT 9930
char SRV_IP[16];

#define bool int
#define true 1
#define false 0

PSP_MODULE_INFO("xbox_ctrl", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);
#define printf pspDebugScreenPrintf
/*************************************************************/
void diep(char *s)
{
  perror(s);
  exit(1);
}

struct sockaddr_in si_me, si_other;
int playerSocket;
bool done = false;
enum
{
  up = 0,
  down,
  left,
  right,
  cross,
  circle,
  square,
  triangle,
  totalButtons, 

};
int buttonStatus[totalButtons];



void InitScreen();
int InitClientSocket();
void ProcessInputs();
int connect_to_apctl(int config);
void ConvertIpToChar(int * _ipDigits, char * _ip);
void GetServerIp(char * _ip);
int GetInput();
void InitButtons();

int exit_callback(int arg1, int arg2, void * common)
{
  sceKernelExitGame();
  return 0;

}

int CallbackThread(SceSize args, void * argp)
{
  int cbid;
  cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
  sceKernelRegisterExitCallback(cbid);
  sceKernelSleepThreadCB();
  return 0;
}

int SetupCallbacks(void)
{
  int thid = 0;
  thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 
                                0xFA0, 0, 0);
  if (thid >= 0)
  {
    sceKernelStartThread(thid, 0, 0);
  }
  return thid;
}

int main()
{
  pspDebugScreenInit();
  SetupCallbacks();
  printf("Setting up client socket\n");

  GetServerIp(SRV_IP); 
  pspDebugScreenSetXY(0,10);
  InitClientSocket();

  sceKernelDelayThread(500000);

  InitButtons();

  while (!done)
  {
    ProcessInputs();
  }
  sceKernelSleepThread();
  return 0;
}
void InitButtons()
{
  int x = 0;
  for (x = 0; x< totalButtons; x++)
    buttonStatus[x] = 0;
}

/*************************************************************/
int InitClientSocket()
{
  int s, err, i, j, slen=sizeof(si_other);
  char buf[BUFLEN];
  printf("INITCLIENTSOCKET!\n");
  if (pspSdkLoadInetModules() < 0)
  {
    printf("COULD NOT LOAD INET MODULES!\n");
    sceKernelSleepThread();
    return 0;
  }
  printf("InetModules Loaded!\n");

/*
  thid = sceKernelCreateThread("net_thread", net_thread, 0x18, 0x10000, PSP_THREAD_ATTR_USER, NULL);
  if (thid < 0)
  {
    printf("Error could not create thread!\n");
    sceKernelSleepThread();
    return 0;
  }
  sceKernelStartThread(thid, 0, NULL);
  sceKernelExitDeleteThread(0);
  sceKernelSleepThread();
*/
  if((err = pspSdkInetInit()))
  {
    printf(": Error, could not initialise the network \n", err);
  }
  printf("Now connecting to 0\n");
  if(connect_to_apctl(0))
  {
    // connected, get my IPADDR and run test
    char szMyIPAddr[32];
    printf("Success!\n");
    if (sceNetApctlGetInfo(8, szMyIPAddr) != 0)
      strcpy(szMyIPAddr, "unknown IP address");  
  }

  if ((playerSocket=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP))==-1)
   diep("socket");

  memset((char *) &si_other, sizeof(si_other), 0);
  si_other.sin_family = AF_INET;
  si_other.sin_port = htons(PORT);
  if (inet_aton(SRV_IP, &si_other.sin_addr)==0)
  {
    fprintf(stderr, "inet_aton() failed\n");
    exit(1);
  }
  printf("Sending packet %d\n", i);
  sprintf(buf, "This is packet %d\n", i);
  if (sendto(playerSocket, buf, BUFLEN, 0, &si_other, slen)==-1)
    diep("sendto()");
}
int connect_to_apctl(int config)
{
  int err;
  int stateLast = -1;
  printf("Inside connect_to_ap\n");
  /* Connect using the first profile */
  err = sceNetApctlConnect(config);
  if (err != 0)
  {
    printf(": sceNetApctlConnect returns %08X\n", err);
    return 0;
  }

  printf(": Connecting...\n");
  while (1)
  {
    int state;
    err = sceNetApctlGetState(&state);
    if (err != 0)
    {
      printf(": sceNetApctlGetState returns $%x\n" , err);
      break;
    }
    if (state > stateLast)
    {
      printf("  connection state %d of 4\n", state);
      stateLast = state;
    }
    if (state == 4)
      break;  // connected with static IP

    // wait a little before polling again
    sceKernelDelayThread(50*1000); // 50ms
  }
  printf(": Connected!\n");

  if(err != 0)
  {
    return 0;
  }
  return 1;
}
#if 0
  char buf[512];
  memset(buf, 0, 512);
  BuildMessage(buf);
  if (sendto(playerSocket,buf,BUFLEN,0,&si_other,slen) == -1)
    printf("Could not send packet!\n");
  printf("\x1b[19;10H");
  printf("Message Sent      ");
#endif

/*************************************************************/

void ProcessInputs()
{
  SceCtrlData pad;
  bool success = false;
  while(!success)
  {
    sceCtrlReadBufferPositive(&pad, 1);
    InitButtons();
    if (pad.Buttons !=0)
    {
      if (pad.Buttons & PSP_CTRL_SQUARE)
      {
        buttonStatus[square] = 1;
        //Square
      }
      if (pad.Buttons & PSP_CTRL_TRIANGLE)
      {
        buttonStatus[triangle] = 1;
        //Triangle
      }
      if (pad.Buttons & PSP_CTRL_CIRCLE)
      {
        buttonStatus[circle] = 1;
        //done = true;
        //Circle
      }
      if (pad.Buttons & PSP_CTRL_CROSS)
      {
        buttonStatus[cross] = 1;
        //Cross
      }
      if (pad.Buttons & PSP_CTRL_UP)
      {
        buttonStatus[up] = 1;
        //Up
      }
      if (pad.Buttons & PSP_CTRL_DOWN)
      {
        buttonStatus[down] = 1;
        //DOWN
      }
      if (pad.Buttons & PSP_CTRL_LEFT)
      {
        buttonStatus[left] = 1;
        //Left
      }
      if (pad.Buttons & PSP_CTRL_RIGHT)
      {
        buttonStatus[right] = 1;
        //Right
      }
      if (pad.Buttons & PSP_CTRL_START)
      {
        //Start
      }
      if (pad.Buttons & PSP_CTRL_SELECT)
      {
        //Select
      }
      if (pad.Buttons & PSP_CTRL_LTRIGGER)
      {
        //LTRIGGER
      }
      if (pad.Buttons & PSP_CTRL_RTRIGGER)
      {
        //RTrigger
      }

      sceKernelDelayThread(100000);

    }
    SendButtonStatus();
  }

}
void SendButtonStatus()
{

  int slen = sizeof(si_other);
  char buf[512];
  memset(buf, 0, 512);
  sprintf(buf,"##U%dD%dL%dR%dA%dB%dX%dY%d!!", 
                buttonStatus[up],
                buttonStatus[down],
                buttonStatus[left],
                buttonStatus[right],
                buttonStatus[cross],
                buttonStatus[circle],
                buttonStatus[square],
                buttonStatus[triangle]);

  if (sendto(playerSocket,buf,BUFLEN,0,&si_other,slen) == -1)
    printf("Could not send packet!\n");

}
/*************************************************************/
void GetServerIp(char * _ip)
{
  int xPos = 0;
  int x;
  bool ipDone = false;
  int button = 0;
  int ipDigits[16] ;
  for (x = 0; x< 16; x++)
    ipDigits[x] = 0;
  pspDebugScreenSetXY(0,5);
  printf("Please Enter Server Ip Address and press X when done");
  pspDebugScreenSetXY(0,6);
  printf("000.000.000.000");
  while (!ipDone)
  {
    sceKernelDelayThread(250000);
    button = GetInput();
    if (button == PSP_CTRL_CROSS)
    {
      ipDone = true;
    } 
    if (button == PSP_CTRL_UP)
    {
      ipDigits[xPos] ++;
      if (ipDigits[xPos] > 9)
        ipDigits[xPos] = 0;
      pspDebugScreenSetXY(xPos,6);
      printf("%d", ipDigits[xPos]);
    }
    if (button == PSP_CTRL_DOWN)
    {
      ipDigits[xPos] --;
      if (ipDigits[xPos] < 0)
        ipDigits[xPos] = 9;
      pspDebugScreenSetXY(xPos,6);
      printf("%d", ipDigits[xPos]);
    }
    if (button == PSP_CTRL_RIGHT)
    {
      pspDebugScreenSetXY(xPos,7);
      printf(" ");
      xPos ++;
      if (xPos == 3 || xPos == 7 || xPos == 11)
        xPos++;
      if (xPos > 14)
        xPos = 0;
      pspDebugScreenSetXY(xPos,7);
      printf("^");
    }
    if (button == PSP_CTRL_LEFT)
    {
      pspDebugScreenSetXY(xPos,7);
      printf(" ");
      xPos --;
      if (xPos == 3 || xPos == 7 || xPos == 11)
        xPos--;
      if (xPos <0 )
        xPos = 14;
      pspDebugScreenSetXY(xPos,7);
      printf("^");
    }
    ConvertIpToChar(ipDigits,_ip);    
    

  }


}
/*************************************************************/
void ConvertIpToChar(int * _ipDigits, char * _ip)
{
  int x = 0;
  int totalChars = 0;
  bool start = true;
  for (x = 0; x<15; x++)
  {
    if (x == 3 || x == 7 || x == 11)
    {
      _ip[totalChars] = '.';
      start = true;
      totalChars ++;
    }
    else if (start && _ipDigits[x] == 0)
      continue;
    else
    {
      switch (_ipDigits[x])
      {
        case (0):
        {
          _ip[totalChars] = '0';
          totalChars ++;
          break;
        }
        case (1):
        {
          _ip[totalChars] = '1';
          totalChars ++;
          break;
        }
        case (2):
        {
          _ip[totalChars] = '2';
          totalChars ++;
          break;
        }
        case (3):
        {
          _ip[totalChars] = '3';
          totalChars ++;
          break;
        }
        case (4):
        {
          _ip[totalChars] = '4';
          totalChars ++;
          break;
        }

        case (5):
        {
          _ip[totalChars] = '5';
          totalChars ++;
          break;
        }
        case (6):
        {
          _ip[totalChars] = '6';
          totalChars ++;
          break;
        }
        case (7):
        {
          _ip[totalChars] = '7';
          totalChars ++;
          break;
        }
        case (8):
        {
          _ip[totalChars] = '8';
          totalChars ++;
          break;
        }
        case (9):
        {
          _ip[totalChars] = '9';
          totalChars ++;
          break;
        }
      }
      start = false;
    } 
  }
  _ip[totalChars] = '\0';



}
/*************************************************************/
int GetInput()
{
  SceCtrlData pad;
  bool success = false;
  while(!success)
  {
    sceCtrlReadBufferPositive(&pad, 1);
    if (pad.Buttons !=0)
    {
      if (pad.Buttons & PSP_CTRL_SQUARE)
      {
        success = true;
        return PSP_CTRL_SQUARE;
        //Square
      }
      if (pad.Buttons & PSP_CTRL_TRIANGLE)
      {
        success = true;
        return PSP_CTRL_TRIANGLE;
        //Triangle
      }
      if (pad.Buttons & PSP_CTRL_CIRCLE)
      {
        success = true;
        return PSP_CTRL_CIRCLE;
        //Circle
      }
      if (pad.Buttons & PSP_CTRL_CROSS)
      {
        success = true;
        return PSP_CTRL_CROSS;
        //Cross
      }
      if (pad.Buttons & PSP_CTRL_UP)
      {
        success = true;
        return PSP_CTRL_UP;
        //Up
      }
      if (pad.Buttons & PSP_CTRL_DOWN)
      {
        success = true;
        return PSP_CTRL_DOWN;
        //DOWN
      }
      if (pad.Buttons & PSP_CTRL_LEFT)
      {
        success = true;
        return PSP_CTRL_LEFT;
        //Left
      }
      if (pad.Buttons & PSP_CTRL_RIGHT)
      {
        success = true;
        return PSP_CTRL_RIGHT;
        //Right
      }
      if (pad.Buttons & PSP_CTRL_START)
      {
        success = true;
        return PSP_CTRL_SQUARE;
        //Start
      }
      if (pad.Buttons & PSP_CTRL_SELECT)
      {
        success = true;
        return PSP_CTRL_SELECT;
        //Select
      }
      if (pad.Buttons & PSP_CTRL_LTRIGGER)
      {
        success = true;
        return PSP_CTRL_LTRIGGER;
        //LTRIGGER
      }
      if (pad.Buttons & PSP_CTRL_RTRIGGER)
      {
        success = true;
        return PSP_CTRL_RTRIGGER;
        //RTrigger
      }
      sceKernelDelayThread(250000);
    }
  }
}

